      PROGRAM AUTOTIME
C...BEGIN PROLOGUE TIMESET
C...DATE WRITTEN 980428 (YYMMDD)
C...REVISION DATE 010829 (YYMMDD)
C...KEYWORDS DECIMAL TIME, DAYS, HOURS, MINUTES, SECONDS
C...EASY TO USE TIMESETTING PROGRAM
C...AUTHOR FIELD, M. S. (EPA)
C...PURPOSE To convert sample time data recorded in coventional
C...units (military time) to decimal time for easy manipulation
C...by QTRACER.
C...
C...
C...DESCRIPTION
C...
C...AUTOTIME.FOR -- Converts time data to decimal time.
C...Easy to Use.
C...
C...This program reads in simple one-dimensional time data arrays
C...and converts the data to decimal time units.  User may choose
C...decimal days, decimal hours, decimal minutes, or decimal seconds.
C...Decimal hours are preferred and are expected to be used most often.
C...
C...Idea for the program developed from the BASIC program written by
C...Mull, Liebermann, Smoot, and Woolsey of the USGS for USEPA,
C...Region IV.	USGS program produced time in decimal hours only.
C...
C...QTRACER2 requires sample time data be listed in decimal time so the
C...output file created by AUTOTIME should be appended to the end of
C...a QTRACER2 SAMPLE STATION data file (e.g., *.DAT).  Corresponding
C...concentration and, if appropriate, discharge data listed alongside
C...the appropriate decimal time data value.
C...
C...END PROLOGUE AUTOTIME
C...
C -------------------------------------------------------------------
C...
C...CALL DFLIB FOR PREPARING GRAPHICS SCREEN
	USE DFLIB
C...
C...SET SPOOLER
	USE FORTRAN_WINPRINT
	IMPLICIT NONE
C...
C...SET TYPE FOR GRAPHICS SCREEN
	TYPE (QWINFO) WINFO
C...
C...IDENTIFY VARIABLES
      CHARACTER	FILEIN*80, FILEOUT*80, FPRINT*1, VIEW*1, DISC*1
	INTEGER(2)	J1
      INTEGER		N1, N2, N3, J2, DAYS, INDEX, IN, KN, LENCHR
      REAL		BEG, H1, M1, THLAG, TIME, C1, D1, HR
C...
C...INCLUDE FORMATTING STATEMENTS
	INCLUDE 'FORMAT.INC'
C...
C...SET LARGEST FRAME WINDOW AND CHILD WINDOW SIZES
	WINFO.TYPE = QWIN$MAX
	J2 = SETWSIZEQQ(QWIN$FRAMEWINDOW,WINFO)
	J2 = SETWSIZEQQ(0,WINFO)
C...
C...TURN ON BLINKING CURSOR
	J1 = DISPLAYCURSOR($GCURSORON)
C...
C...INITIATE PROGRAM OPERATION
	CALL GREET()
	CALL CLEARSCREEN ($GCLEARSCREEN)
C...
C -------------------------------------------------------------------
C...
C...BEGIN PROGRAM OPERATION BY DETERMINING APPROPRIATE TIME UNITS
	WRITE (*,800, ADVANCE='NO')
      READ  (*,*) INDEX
	CALL CLEARSCREEN ($GCLEARSCREEN)
C...
C...SET TIME CONVERSION TO DESIRED DECIMAL UNITS
	IF (INDEX .EQ. 1) THEN
		TIME = 1.0E0/24.0E0
	ELSEIF (INDEX .EQ. 2) THEN
		TIME = 1.0E0
	ELSEIF (INDEX .EQ. 3) THEN
		TIME = 60.0E0
	ELSEIF (INDEX .EQ. 4) THEN
		TIME = 3.6E03
	ENDIF
C...
C...OPEN INPUT FILE -- CLEAR AND REDO IF INPUT FILE DOES NOT EXISTS
	IN = 0
5	CONTINUE
	IN = IN+1
	IF (IN .GT. 1) THEN
		CALL CLEARSCREEN ($GCLEARSCREEN)
		IF (KN .LE. 50) THEN
			WRITE (*,820) FILEIN
		ELSE
			WRITE (*,830) FILEIN
		ENDIF
	ENDIF
	WRITE (*,810, ADVANCE='NO')
	READ  (*,840) FILEIN
	KN = LENCHR(FILEIN)
	IF (KN .LT. 1) FILEIN = 'AUTOTIME.DAT'
	OPEN (1, FILE = FILEIN, ACCESS = 'SEQUENTIAL', 
	1	  STATUS = 'OLD', READONLY, ERR = 5)
	CALL CLEARSCREEN ($GCLEARSCREEN)
C...
C...CHECK FOR TWO-COLUMN OR THREE-COLUMN DATA FILE
	WRITE (*,860, ADVANCE='NO')
	IF (FILEIN .EQ. 'AUTOTIME.DAT')	WRITE (*,870, ADVANCE='NO')
      READ  (*,*) DISC
	CALL CLEARSCREEN ($GCLEARSCREEN)
C...
C...OPEN OUTPUT FILE AND CHECK FOR EXISTING NAMES
10	WRITE (*,880, ADVANCE='NO')
	READ  (*,840) FILEOUT
	IF (FILEOUT .EQ. FILEIN) THEN
	    WRITE (*,850)
	    WRITE (*,900, ADVANCE='NO')
		READ  (*,*)
		CALL CLEARSCREEN ($GCLEARSCREEN)
	    GOTO 10
	ENDIF
	KN = LENCHR (FILEOUT)
	IF (KN .LT. 1) FILEOUT = 'AUTOTIME.OUT'
	KN = LENCHR (FILEOUT)
	OPEN (2, FILE = FILEOUT, STATUS = 'UNKNOWN')
	CALL CLEARSCREEN ($GCLEARSCREEN)
C...
C...CHECK FOR SCREEN VIEWING OF OUTPUT DATA
	WRITE (*,910)
	READ  (*,*) VIEW
	CALL CLEARSCREEN ($GCLEARSCREEN)
	WRITE (*,890)
C...
C...ZERO COUNTERS
      N1 = 0
	N2 = 0
	N3 = 0
C...
C...READ DATA
  100 CONTINUE
	IF ((DISC(1:1) .EQ. "Y") .OR. (DISC(1:1) .EQ. "y")) THEN
		READ (1,*,END = 150) H1,M1,C1,D1
      ELSE
		READ (1,*,END = 150) H1,M1,C1
      ENDIF
      IF (M1 .LT. 0.0E0) GOTO 100
      N1 = N1+1
C...
C...CALCULATE TIME IN DECIMAL HOURS
      IF (N1 .EQ. 1) THEN
		BEG = H1 + (M1/60.0E0)
      ELSEIF (THLAG .GT. H1) THEN
		DAYS = DAYS+1
      ENDIF
C...
      HR = H1+(M1/60.0E0) - BEG+(FLOAT(DAYS)*24.0E0)
      IF (HR .LT. 0.0E0) HR = 0.0E0
      THLAG = H1
C...
C...WRITE OUTPUT TIME IN DESIRED DECIMAL UNITS TO OUTPUT FILE
	IF ((DISC(1:1) .EQ. "Y") .OR. (DISC(1:1) .EQ. "y")) THEN
		IF (HR*TIME .LT. 1.0E05) THEN
			WRITE (2,1010) HR*TIME,C1,D1
		ELSE
			WRITE (2,1015) HR*TIME,C1,D1
		ENDIF
      ELSE
		IF (HR*TIME .LT. 1.0E05) THEN
			WRITE (2,1010) HR*TIME,C1
		ELSE
			WRITE (2,1015) HR*TIME,C1
		ENDIF
      ENDIF
C...
C...WRITE OUTPUT TIME IN DESIRED DECIMAL UNITS TO SCREEN DEVICE
	IF ((VIEW(1:1) .EQ. "Y") .OR. (VIEW(1:1) .EQ. "y")) THEN
		IF ((DISC(1:1) .EQ. "Y") .OR. (DISC(1:1) .EQ. "y")) THEN
			IF (HR*TIME .LT. 1.0E05) THEN
				WRITE (*,1000) N1,HR*TIME,C1,D1
			ELSE
				WRITE (*,1005) N1,HR*TIME,C1,D1
			ENDIF
		ELSE
			IF (HR*TIME .LT. 1.0E05) THEN
				WRITE (*,1000) N1,HR*TIME,C1
			ELSE
				WRITE (*,1005) N1,HR*TIME,C1
			ENDIF
		ENDIF
		N2 = N2+1
		N3 = N3+2
		IF (N2 .EQ. 15) THEN
			WRITE (*,900, ADVANCE='NO')
			READ  (*,*)
			N2 = 0
			N3 = 1
		ENDIF
		IF (N3 .EQ. 1) THEN
			CALL CLEARSCREEN ($GCLEARSCREEN)
			WRITE (*,890)
		ENDIF
	ENDIF
C...
C...REPEAT CALCULATION
      GOTO 100
  150 CONTINUE
C...
C...ADJUST SCREEN FOR VIEWING
	IF ((VIEW(1:1) .EQ. "Y") .OR. (VIEW(1:1) .EQ. "y")) THEN
		WRITE (*,900, ADVANCE='NO')
		READ  (*,*)
	ELSE
C...
C...PAUSE PROGRAM IN PREPARATION FOR PRINTING
		WRITE (*,890)
		WRITE (*,900, ADVANCE='NO')
		READ  (*,*)
	ENDIF
	CALL CLEARSCREEN ($GCLEARSCREEN)
C...
C...CHECK FOR FILE PRINTING
	WRITE (*,890)
	WRITE (*,1040) FILEOUT
	READ  (*,*) FPRINT
	IF ((FPRINT(1:1) .EQ. "Y") .OR. (FPRINT(1:1) .EQ. "y")) THEN
		CALL PRINT_UNIT(2,.FALSE.,.FALSE.,1.0,0.5,
	1					1.0,"Courier New"C,9,4)
	ENDIF
	CALL CLEARSCREEN ($GCLEARSCREEN)
C...
C...CLOSE ALL FILES
	CLOSE (UNIT=1, STATUS = 'KEEP')
	CLOSE (UNIT=2, STATUS = 'KEEP')
C...
C...SPECIAL FORMAT STATEMENT FOR PRINTING
1040	FORMAT(////,15X,'DO YOU WANT TO PRINT THE FILE: '
	1				,A<KN>,'? (Y=YES, N=NO)   ',$)
C...
C...DONE
      STOP
      END
C...
C -------------------------------------------------------------------
C...
C...
C...    ******************************************************
C...   *                                                      *
C...   *                  SUBROUTINE GREET                    *
C...   *                                                      *
C...   *          VERSION 1.0 CURRENT AS OF 08/28/01          *
C...   *                                                      *
C...    ******************************************************
C...
C...
C...SUBROUTINE GREET TO INTRODUCE THE PROGRAM ON DEVICE SCREEN
      SUBROUTINE GREET()
	IMPLICIT NONE
C...
C...INCLUDE FORMATTING STATEMENTS
	INCLUDE 'FORMAT.INC'
C...
C...INTRODUCE THE PROGRAM AND DEVELOPER
	WRITE (*,2000)
	WRITE (*,2010, ADVANCE='NO')
	READ  (*,*)
C...
C...FORMAT STATEMENTS

C...
C...DONE
      RETURN
      END
C...
C -------------------------------------------------------------------
C...
C...
C...    ******************************************************
C...   *                                                      *
C...   *                  FUNCTION LENCHR                     *
C...   *                                                      *
C...   *          VERSION 1.0 CURRENT AS OF 10/01/99          *
C...   *                                                      *
C...    ******************************************************
C...
C...
C...FUNCTION LENCHR CALCULATES THE LENGTH OF A CHARACTER STRING
C...(CODE FROM R. STEVE REGAN, USGS)
      INTEGER FUNCTION LENCHR (STRING)
	IMPLICIT NONE
C...
C...IDENTIFY FUNCTION VALIABLES
      CHARACTER*(*) STRING
C...
C...ARGUMENT DEFINITIONS
C...STRING -> INPUT STRING TO DETERMINE LENGTH
C...
C...LOCAL VARIABLES
      INTEGER(4) MAXL, I
C...
C...INTRINSICS
      INTEGER(4) LEN
      INTRINSIC  LEN
C...
C...SET INITIAL MAXIMUM STRING LENGTH
      MAXL = LEN(STRING)
C...
C...ADJUST MAXIMUM STRING LENGTH AS APPROPRIATE
      DO I = MAXL,1,-1
		IF (STRING(I:I).NE.' ') THEN
			LENCHR = I
			GOTO 20
		ENDIF
	ENDDO
C...
C...RESET LENCHR TO ZERO LENGTH
      LENCHR = 0
C...
C...DONE
20	RETURN
      END